package bg.bas.dcl.CorpusTools;

import java.io.File;
import java.io.FileInputStream;
import java.io.FileNotFoundException;
import java.io.FileOutputStream;
import java.io.IOException;
import java.io.OutputStreamWriter;
import java.io.UnsupportedEncodingException;
import java.io.Writer;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.Collections;
import java.util.HashMap;
import java.util.List;
import java.util.Scanner;
import java.util.Set;

import javax.xml.parsers.DocumentBuilder;
import javax.xml.parsers.DocumentBuilderFactory;
import javax.xml.parsers.ParserConfigurationException;

import org.w3c.dom.Document;
import org.w3c.dom.Element;
import org.w3c.dom.Node;
import org.w3c.dom.NodeList;
import org.w3c.dom.bootstrap.DOMImplementationRegistry;
import org.w3c.dom.ls.DOMImplementationLS;
import org.w3c.dom.ls.LSSerializer;
import org.xml.sax.SAXException;

import bg.bas.dcl.mwe.entities.*;

public class ProcessClauses {

    static String NL = System.getProperty("line.separator");
	final static HashMap<String,Double> priors = new HashMap<String,Double>();

    
    static HashMap<String,Integer> ctrs = new HashMap<String, Integer>();
	static int fc = 0;
	static int c = 1;
	
    public static void increaseCtr (String ctrname) {
    	int c;
    	
    	if (ctrs.containsKey(ctrname)) c = ctrs.get(ctrname) + 1;
    	else c = 1;
    	ctrs.put(ctrname, c);
    }
    public static void increaseCtrBy (String ctrname, int q) {
    	int c;
    	
    	if (ctrs.containsKey(ctrname)) c = ctrs.get(ctrname) + q;
    	else c = 1;
    	ctrs.put(ctrname, c);
    }
    
    public static double findDistMeasure (int len1, int len2, String model) {

    	
    	double distmeasure;
    	final double BIGdistmeasure = 2500;
    	
    	final double foreign_chars_per_eng_char = 1.09;
    	final double var_per_eng_char = 8.7;
       
    	if (len1==0 && len2==0) return 0;

    	double mean = (len1 + len2/foreign_chars_per_eng_char)/2;
    	
    	double z = Math.abs((foreign_chars_per_eng_char * len1 - len2)/Math.sqrt(var_per_eng_char * mean));
    	
    	double pd = 2 * (1 - pnorm(z));

    	if(true) return (foreign_chars_per_eng_char * len1 - len2)/Math.sqrt(var_per_eng_char * mean);
        
    	if (pd > 0) {
       		double prob = (priors.containsKey(model) ? priors.get(model) : 0.0001);
       		double prob11 = priors.get("1,1");
    		System.out.println(prob + "\t" + "");
    		
    		distmeasure = -100 * Math.log(pd) -100* Math.log(prob/prob11);
    		
    		return distmeasure;
    	}
        else return (BIGdistmeasure);

    }
   
   public static double findDistMeasure_old (int len1, int len2, String model) {

    	
    	double distmeasure;
    	final double BIGdistmeasure = 2500;
    	
    	final double foreign_chars_per_eng_char = 1.09;
    	final double var_per_eng_char = 8.7;
       
    	if (len1==0 && len2==0) return 0;

    	double mean = (len1 + len2/foreign_chars_per_eng_char)/2;
    	
    	double z = Math.abs((foreign_chars_per_eng_char * len1 - len2)/Math.sqrt(var_per_eng_char * mean));
    	
    	double pd = 2 * (1 - pnorm(z));

    	if(true) return (foreign_chars_per_eng_char * len1 - len2)/Math.sqrt(var_per_eng_char * mean);
        
    	if (pd > 0) {
       		double prob = (priors.containsKey(model) ? priors.get(model) : 0.0001);
       		double prob11 = priors.get("1,1");
    		System.out.println(prob + "\t" + "");
    		
    		distmeasure = -100 * Math.log(pd) -100* Math.log(prob/prob11);
    		
    		return distmeasure;
    	}
        else return (BIGdistmeasure);

    }

    
	public static double pnorm(double z){
	    // Returns the area under a normal distribution
	    // from -inf to z standard deviations 
	    
	    double t = 1/(1 + 0.2316419 * z);
	    double pd = 1 - 0.3989423 * Math.exp(-z * z/2) * 
	      			((((1.330274429 * t - 1.821255978) * t 
	      			+ 1.781477937) * t - 0.356563782) * t + 0.319381530) * t;
	    /* see Gradsteyn & Rhyzik, 26.2.17 p932 */
	    return pd;
	
	}
    
	
	public static void main(String[] args) {
		String mainpath = args[0]; // "/home/ivelina/phd/clause_alignment/results/Corpus/full";
		
		
		sentStatistics(mainpath);
	}
	
	
	
	public static void sentStatistics(String mainpath) {
		ctrs.put("1-1", 0);
		ctrs.put("1-2", 0);
		ctrs.put("1-3", 0);
		ctrs.put("2-1", 0);
		ctrs.put("3-1", 0);
		
		
		List<File> files;
		try {
			files = getFileListing(new File(mainpath));
		
		
		boolean auto = false;
		
	    for(File file : files){

	        HashMap<String,SentenceCl> sent_man_bg = new HashMap<String,SentenceCl>();
	        HashMap<String,SentenceCl> sent_man_en = new HashMap<String,SentenceCl>();
	        HashMap<String,SentenceCl> sent_auto_bg = new HashMap<String,SentenceCl>();
	        HashMap<String,SentenceCl> sent_auto_en = new HashMap<String,SentenceCl>();

	        ArrayList<String> sent_ordermbg = new ArrayList<String>();
	        ArrayList<String> sent_orderabg = new ArrayList<String>();
	        ArrayList<String> sent_ordermen = new ArrayList<String>();
	        ArrayList<String> sent_orderaen = new ArrayList<String>();

	    	
	    	if (file.isFile()){
	    		
		    	if (!file.getAbsolutePath().endsWith(".txt")) continue;
//	    		if (!file.getName().contains("SVETLA")) continue;
	    		
	    	for (int j=0; j<2; j++) {
	    		
	    		String fname = file.getAbsolutePath();
	    		
	    		if (j==2) fname = fname.replace(".txt", ".al");
	    		if (j==3) {
	    			fname = fname.replace("etal", "hypo");
	    			fname = fname.replace(".txt", ".al");
	    		}
	    		
	    		System.out.println(fname);
	    		
	    		DocumentBuilderFactory builderFactory = DocumentBuilderFactory.newInstance();
	    		DocumentBuilder builder = builderFactory.newDocumentBuilder();
	    		Document document = builder.parse(new FileInputStream(fname));
	    		
	    		Element rootElement = document.getDocumentElement();
	    		
		    	DOMImplementationRegistry registry = DOMImplementationRegistry.newInstance();
		    	DOMImplementationLS lsImpl = 
		    	   (DOMImplementationLS)registry.getDOMImplementation("LS");
		    	LSSerializer serializer = lsImpl.createLSSerializer();

		    	NodeList nodes = rootElement.getChildNodes();
		    	SentenceCl sen = new SentenceCl();
			    boolean validSent = false;
			    boolean errorSent = false;

		    	for(int i=0; i<nodes.getLength(); i++){
			    	  Node node = nodes.item(i);
			    	  if(node instanceof Element){
			    		  Element child = (Element) node;
			    		  Clause cl;
			    		  
						  if (!validSent) {
						  	sen = new SentenceCl();
						   	validSent = true;
						  }

				    	  String cl_attr = child.getAttribute("cl").trim();
				    	  String sen_attr = child.getAttribute("sen").trim();
				    	  String end_attr = child.getAttribute("e").trim();
				    	  String word = child.getAttribute("w").trim();
				    	  

				    	  String sen_al = child.getAttribute("sen_al").trim();
				    	  String cl_al = child.getAttribute("cl_al").trim();

				    	  if (sen_al!=null && !sen_al.equals("")) sen.sent_align = sen_al;
				    	  
				    	  
				    	  if (cl_attr == null || cl_attr.equals("")) continue;

				    	  if (sen_attr != null && !sen_attr.equals("")) sen.id = sen_attr;
				    	  
				    	  if (sen.containsKey(cl_attr)) {
				    	    	cl = sen.get(cl_attr); 
				    	  } else {
				    	    	cl = new Clause();
				    	    	cl.id = cl_attr;
				    	    	cl.lenInChars = 0;
				    	    	cl.lenInWords = 0;
				    	    	sen.clauseOrder.add(cl_attr);
				    	  } 
				    	  
			    	  }
		    	}
	    	}
	    	}
	    }

		} catch (FileNotFoundException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		} catch (ParserConfigurationException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		} catch (SAXException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		} catch (IOException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		} catch (ClassCastException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		} catch (ClassNotFoundException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		} catch (InstantiationException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		} catch (IllegalAccessException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}

		
	}

	
	/**
	 * 
	 * @param args
	 */
	public static void clauseStatistics(String mainpath) {
		// TODO Auto-generated method stub
		
		String outfolder = "";
		
    	priors.put("0,1", 0.0047);
    	priors.put("1,2", 0.1023);
    	priors.put("1,3", 0.0188);
    	priors.put("1,0", 0.0019);
    	priors.put("1,1", 0.8347);
    	priors.put("2,1", 0.0254);
    	priors.put("2,3", 0.0009);
    	priors.put("2,2", 0.0038);
    	priors.put("3,1", 0.0009);
    	priors.put("3,2", 0.00001);
    	priors.put("3,3", 0.00001);

		ctrs.put("words--bg", 0);
		ctrs.put("words--en", 0);

		ctrs.put("sent--bg", 0);
		ctrs.put("sent--en", 0);
		ctrs.put("sent-err-bg", 0);
		ctrs.put("sent-err-en", 0);

		ctrs.put("cl--bg", 0);
		ctrs.put("cl--en", 0);
		ctrs.put("cl--bga", 0);
		ctrs.put("cl--ena", 0);


//		String mainpath = args[0];
	    String punct = ".,;'#!\"?<|\\&^()+_-=*~$£>";
	    

		try{
			Writer lenout = new OutputStreamWriter(new FileOutputStream(outfolder+"/bg_en_sent_lens.txt"),"UTF-8");
			Writer out = new OutputStreamWriter(new FileOutputStream(outfolder+"/error_sents.txt"),"UTF-8");
			Writer outen = new OutputStreamWriter(new FileOutputStream(outfolder+"/error_sents.al"),"UTF-8");
			Writer outcor = new OutputStreamWriter(new FileOutputStream(outfolder+"/correct_sents.txt"),"UTF-8");
			Writer outcoren = new OutputStreamWriter(new FileOutputStream(outfolder+"/correct_sents.al"),"UTF-8");

			Writer outdist = new OutputStreamWriter(new FileOutputStream(outfolder+"/dist_measure.txt"),"UTF-8");
			Writer outcrossed = new OutputStreamWriter(new FileOutputStream(outfolder+"/complicated-crossed.txt"),"UTF-8");
			Writer outcrosseden = new OutputStreamWriter(new FileOutputStream(outfolder+"/complicated-crossed.al"),"UTF-8");
			Writer outdistant = new OutputStreamWriter(new FileOutputStream(outfolder+"/complicated-distant.txt"),"UTF-8");
			Writer outdistanten = new OutputStreamWriter(new FileOutputStream(outfolder+"/complicated-distant.al"),"UTF-8");

		out.write("<?xml version=\"1.0\" ?>\n<text current=\"0\">");
		outen.write("<?xml version=\"1.0\" ?>\n<text current=\"0\">");
		outcor.write("<?xml version=\"1.0\" ?>\n<text current=\"0\">");
		outcoren.write("<?xml version=\"1.0\" ?>\n<text current=\"0\">");

		outcrossed.write("<?xml version=\"1.0\" ?>\n<text current=\"0\">");
		outcrosseden.write("<?xml version=\"1.0\" ?>\n<text current=\"0\">");
		outdistant.write("<?xml version=\"1.0\" ?>\n<text current=\"0\">");
		outdistanten.write("<?xml version=\"1.0\" ?>\n<text current=\"0\">");

		      
		List<File> files = getFileListing(new File(mainpath));
		
	
		boolean auto = false;
		
	    for(File file : files){

	        HashMap<String,SentenceCl> sent_man_bg = new HashMap<String,SentenceCl>();
	        HashMap<String,SentenceCl> sent_man_en = new HashMap<String,SentenceCl>();
	        HashMap<String,SentenceCl> sent_auto_bg = new HashMap<String,SentenceCl>();
	        HashMap<String,SentenceCl> sent_auto_en = new HashMap<String,SentenceCl>();

	        ArrayList<String> sent_ordermbg = new ArrayList<String>();
	        ArrayList<String> sent_orderabg = new ArrayList<String>();
	        ArrayList<String> sent_ordermen = new ArrayList<String>();
	        ArrayList<String> sent_orderaen = new ArrayList<String>();

	    	
	    	if (file.isFile()){
	    		
		    	if (!file.getAbsolutePath().endsWith(".txt")) continue;
//	    		if (!file.getName().contains("SVETLA")) continue;
	    		
	    	for (int j=0; j<4; j++) {
	    		
	    		String fname = file.getAbsolutePath();
	    		
	    		if (j==1) fname = fname.replace("etal", "hypo");
	    		if (j==2) fname = fname.replace(".txt", ".al");
	    		if (j==3) {
	    			fname = fname.replace("etal", "hypo");
	    			fname = fname.replace(".txt", ".al");
	    		}
	    		
	    		System.out.println(fname);
	    		
	    		DocumentBuilderFactory builderFactory = DocumentBuilderFactory.newInstance();
	    		DocumentBuilder builder = builderFactory.newDocumentBuilder();
	    		Document document = builder.parse(new FileInputStream(fname));
	    		
	    		Element rootElement = document.getDocumentElement();
	    		
		    	DOMImplementationRegistry registry = DOMImplementationRegistry.newInstance();
		    	DOMImplementationLS lsImpl = 
		    	   (DOMImplementationLS)registry.getDOMImplementation("LS");
		    	LSSerializer serializer = lsImpl.createLSSerializer();

		    	NodeList nodes = rootElement.getChildNodes();
		    	SentenceCl sen = new SentenceCl();
			    boolean validSent = false;
			    boolean errorSent = false;

		    	for(int i=0; i<nodes.getLength(); i++){
			    	  Node node = nodes.item(i);
			    	  if(node instanceof Element){
			    		  Element child = (Element) node;
			    		  Clause cl;
			    		  
						  if (!validSent) {
						  	sen = new SentenceCl();
						   	validSent = true;
						  }

				    	  String cl_attr = child.getAttribute("cl").trim();
				    	  String sen_attr = child.getAttribute("sen").trim();
				    	  String end_attr = child.getAttribute("e").trim();
				    	  String word = child.getAttribute("w").trim();
				    	  

				    	  String sen_al = child.getAttribute("sen_al").trim();
				    	  String cl_al = child.getAttribute("cl_al").trim();

				    	  if (sen_al!=null && !sen_al.equals("")) sen.sent_align = sen_al;
				    	  
				    	  
				    	  if (cl_attr == null || cl_attr.equals("")) continue;

				    	  if (sen_attr != null && !sen_attr.equals("")) sen.id = sen_attr;
				    	  
				    	  if (sen.containsKey(cl_attr)) {
				    	    	cl = sen.get(cl_attr); 
				    	  } else {
				    	    	cl = new Clause();
				    	    	cl.id = cl_attr;
				    	    	cl.lenInChars = 0;
				    	    	cl.lenInWords = 0;
				    	    	sen.clauseOrder.add(cl_attr);
				    	  } 
				    	  

				    	  if (cl_al!=null && !cl_al.equals("")) cl.clause_align = cl_al;
				    	    
					    	if (word != null && word.length() > 0 && !word.equals("====")) {
					    	    	cl.lenInWords ++;
				    				for (int k=0; k < word.length(); k++) {
				    					if (!punct.contains(word.substring(k,k+1))) {
				    						cl.lenInChars += 1;
				    					}
				    				}			    	    	 
					    	}
					    	sen.put(cl.id, cl);

			    	    	// for validation

						    String XML = serializer.writeToString(node);
						    XML = XML.replace("<?xml version=\"1.0\" encoding=\"UTF-16\"?>", "");
						    XML = XML.replace(NL, "");
						    sen.XMLsentence += XML; // we need it in case of error

						    
						    if (sen.id != null && sen.id.length()>0 && end_attr!=null && end_attr.equals("True")){
						    	
						    	if (sen.sent_align==null || sen.sent_align.equals("")) sen.sent_align = sen.id;

						    	validSent = false;

							    if (j==0) {
								    increaseCtr(sen.size()+"cl_sent--bg");
							    	increaseCtr("sent--bg");
							    	if (sent_man_bg.containsKey(sen.id)) {
							    		SentenceCl s = sent_man_bg.get(sen.id);
							    		s.clauseOrder.addAll(sen.clauseOrder);
							    		for (String key : sen.keySet()) s.put(key,sen.get(key));
							    		if (sen.sent_align != null && sen.sent_align.length()>0) s.sent_align = sen.sent_align;
							    		sent_man_bg.put(sen.id, s);
							    	} else {
									    sent_ordermbg.add(sen.id);
										sent_man_bg.put(sen.id, sen); 
								    	increaseCtrBy("cl--bg",sen.size());
								    	int nw = 0;
								    	for (Clause cla : sen.values()) nw += cla.lenInWords;
								    	increaseCtrBy("words--bg", nw);
							    	}
							    }
							    if (j==1) {
							    	increaseCtr("sent--bga");
							    	if (sent_auto_bg.containsKey(sen.id)) {
							    		SentenceCl s = sent_auto_bg.get(sen.id);
							    		s.clauseOrder.addAll(sen.clauseOrder);
							    		for (String key : sen.keySet()) s.put(key,sen.get(key));
							    		if (sen.sent_align != null && sen.sent_align.length()>0) s.sent_align = sen.sent_align;
							    		sent_auto_bg.put(sen.id, s);
							    	} else {
									    sent_orderabg.add(sen.id);
										sent_auto_bg.put(sen.id, sen); 
							    	}

							    }
							    if (j==2) {
								    increaseCtr(sen.size()+"cl_sent--en");
							    	increaseCtr("sent--en");
							    	if (sent_man_en.containsKey(sen.id)) {
							    		SentenceCl s = sent_man_en.get(sen.id);
							    		s.clauseOrder.addAll(sen.clauseOrder);
							    		for (String key : sen.keySet()) s.put(key,sen.get(key));
							    		if (sen.sent_align != null && sen.sent_align.length()>0) s.sent_align = sen.sent_align;
							    		sent_man_en.put(sen.id, s);
							    	} else {
									    sent_ordermen.add(sen.id);
										sent_man_en.put(sen.id, sen); 
								    	increaseCtrBy("cl--en",sen.size());
								    	int nw = 0;
								    	for (Clause cla : sen.values()) nw += cla.lenInWords;
								    	increaseCtrBy("words--en", nw);

								    }
							    }
							    if (j==3) {
							    	increaseCtr("sent--ena");
								    	if (sent_auto_en.containsKey(sen.id)) {
								    		SentenceCl s = sent_auto_en.get(sen.id);
								    		s.clauseOrder.addAll(sen.clauseOrder);
								    		for (String key : sen.keySet()) s.put(key,sen.get(key));
								    		if (sen.sent_align != null && sen.sent_align.length()>0) s.sent_align = sen.sent_align;
								    		sent_auto_en.put(sen.id, s);
								    	} else {
										    sent_orderaen.add(sen.id);
											sent_auto_en.put(sen.id, sen);
									    	increaseCtrBy("cl--ena",sen.size());
								    	}
									
							    }
							    

						    }
			    	  }
		    	
		    	}
	    	} // j loop


	    	int ncl = 0, nw = 0;
	    	for (String key : sent_man_bg.keySet()) {
	    		ncl += sent_man_bg.get(key).size();
	    		for (Clause cl : sent_man_bg.get(key).values()) {
	    			nw += cl.lenInWords;
	    		}
//	    		System.out.println(sent_man_bg.get(key).id + "\t" + sent_man_bg.get(key).size()+ "\t"+sent_man_en.get(key).size() + sent_ordermbg.contains(key));
	    	} 
//	    	System.err.println(ncl+ "\t" + nw);
//	    	System.err.println(sent_man_bg.keySet().size() + "\t " + sent_ordermbg.size()); 
//	    	System.err.println(sent_auto_bg.keySet().size() + "\t " + sent_orderabg.size()); 
//	    	System.err.println(sent_man_en.keySet().size() + "\t " + sent_ordermen.size()); 
//	    	System.err.println(sent_auto_en.keySet().size() + "\t " + sent_orderaen.size()); 

	    	/**
	    	for (String key : sent_man_en.keySet()) System.err.print(key + "\t");
	    	System.err.println();
	    	System.err.println();
	    	for (String key : sent_ordermen) System.err.print(key + "\t");
	    	System.err.println();
	    	System.err.println();
	    	*/
	    	
	    	
	    	
	    	// evaluation of current text
	    	
sentloop:	    	for (int i=0; i<sent_orderabg.size(); i++) {
	
	
	    		SentenceCl bga = sent_auto_bg.get(sent_orderabg.get(i));
				boolean notoutputaserror = true;
				boolean notoutputcrdist = true;
	    		
	    		SentenceCl bgm = sent_man_bg.get(sent_ordermbg.get(i));
	    		System.out.println(bgm.id + "\t" + bgm.size() +"\tauto "+ bga.id + "\t" + bga.size());

//		    	System.err.println(bga.XMLsentence); 
//		    	System.err.println(bgm.XMLsentence); 

		    	ArrayList<ArrayList<Integer>> alignment = new ArrayList<ArrayList<Integer>>();
		    	ArrayList<ArrayList<Integer>> malignment = new ArrayList<ArrayList<Integer>>();

	    		SentenceCl ena = new SentenceCl();
	    		for (SentenceCl s : sent_auto_en.values()) if (bga.sent_align!= null && (bga.sent_align.equals(s.sent_align))) ena = s;
	    		
	    		if (ena.id!=null && sent_auto_en.containsKey(bga.id)) ena = sent_auto_en.get(bga.id);
	    		

	    		SentenceCl enm = new SentenceCl();
	    		if (ena.id!= null) enm = sent_man_en.get(sent_ordermen.get(sent_orderaen.indexOf(ena.id)));
	    		


		    	ArrayList<Integer> aen = new ArrayList<Integer>();
		    	ArrayList<Integer> men = new ArrayList<Integer>();

		    	for (int j=0; j<bga.clauseOrder.size(); j++) {


		    		Clause clbga = bga.get(bga.clauseOrder.get(j));
		    		Clause clbgm = bgm.get(bgm.clauseOrder.get(j));

		    		if (clbga.clause_align == null || clbga.clause_align.equals("")) clbga.clause_align = clbga.id;
		    		if (clbgm.clause_align == null || clbgm.clause_align.equals("")) clbgm.clause_align = clbgm.id;
	
//		    		System.out.println(bga.id + "\t" + j + "\t" + clbga.id + "\t" + clbga.clause_align);

    		
		    		boolean clTo0 = true;
		    		boolean mclTo0 = true;
		    		
			    	for (int k=0; k<ena.clauseOrder.size(); k++) {
			    		Clause clena = ena.get(ena.clauseOrder.get(k));
			    		Clause clenm = enm.get(enm.clauseOrder.get(k));
			    		if (clena.clause_align == null || clena.clause_align.equals("")) clena.clause_align = clena.id;
			    		if (clenm.clause_align == null || clenm.clause_align.equals("")) clenm.clause_align = clenm.id;
			    		
			    		System.out.println(bga.id + "\t" + j + "\t" + clbga.id + "\t" + clbga.clause_align + "\t" + k + "\t" + clena.clause_align);
			    		
			    		if (clena.clause_align!=null && clena.clause_align.equals(clbga.clause_align)) {
			    			ArrayList<Integer> p = new ArrayList<Integer>();
			    			p.add(j);
			    			p.add(k);
			    			alignment.add(p);
			    			clTo0 = false;
			    			aen.add(k);
			    			if (bga.id.endsWith("30b")) System.err.println("CHECK " + j + " " + k);
			    		}
			    		if (clenm.clause_align!=null && clenm.clause_align.equals(clbgm.clause_align)) {
			    			ArrayList<Integer> p = new ArrayList<Integer>();
			    			p.add(j);
			    			p.add(k);
			    			malignment.add(p);
			    			mclTo0 = false;
			    			men.add(k);
			    			if (bga.id.endsWith("30b")) System.err.println("mCHECK " + j + " " + k);
			    		}
			    	}
			    	
			    	if (clTo0) {
		    			ArrayList<Integer> p = new ArrayList<Integer>();
		    			p.add(j);
		    			p.add(-1);
		    			alignment.add(p);
		    			if (bga.id.endsWith("30b")) System.err.println("CHECK " + j + " " + -1);

			    	}

			    	if (mclTo0) {
		    			ArrayList<Integer> p = new ArrayList<Integer>();
		    			p.add(j);
		    			p.add(-1);
		    			malignment.add(p);
		    			if (bga.id.endsWith("30b")) System.err.println("mCHECK " + j + " " + -1);
			    	}


		    	}
		    	
	    		for (int j=0; j<ena.clauseOrder.size(); j++) {
	    			if (!aen.contains(j)) {
		    			ArrayList<Integer> p = new ArrayList<Integer>();
		    			p.add(-1);
		    			p.add(j);
		    			alignment.add(p);
		    			if (bga.id.endsWith("30b")) System.err.println("CHECK " + -1 + " " + j);
	    			}
		    		
	    			if (!men.contains(j)) {
		    			ArrayList<Integer> p = new ArrayList<Integer>();
		    			p.add(-1);
		    			p.add(j);
		    			malignment.add(p);
		    			if (bga.id.endsWith("30b")) System.err.println("mCHECK " + -1 + " " + j);
	    			}
  			
	    		}

	    	
		    	// evaluation
		    	// output errors
	    		ArrayList<Integer> coveredClauses = new ArrayList<Integer>();
	    		ArrayList<Integer> coveredClausesm = new ArrayList<Integer>();
	    		ArrayList<HashMap<String, ArrayList<Integer>>> mbeads = new ArrayList<HashMap<String, ArrayList<Integer>>>();
	    		
		    	for(int j = 0; j<malignment.size(); j++) {
		    		int bgcl_index = malignment.get(j).get(0);
		    		int encl_index = malignment.get(j).get(1);
		    		String model;

		    		if (!coveredClausesm.contains(bgcl_index)) {
			    		HashMap<String, ArrayList<Integer>> beadm = new HashMap<String, ArrayList<Integer>>();
			    		beadm.put("bg", new ArrayList<Integer>());
			    		beadm.put("en", new ArrayList<Integer>());

			    		beadm.get("bg").add(bgcl_index);
		    			beadm.get("en").add(encl_index);
		    			for(int k = j+1; k<malignment.size(); k++) {
		    				if (bgcl_index!=-1 && malignment.get(k).get(0)==bgcl_index) {
		    					beadm.get("en").add(malignment.get(k).get(1));
					    		
		    				}
		    				if (encl_index!=-1 && malignment.get(k).get(1)==encl_index) {
		    					beadm.get("bg").add(malignment.get(k).get(0));
		    				}
		    			}
		    			coveredClausesm.add(bgcl_index);
		    			
		    			int[] sizes = {0,0};
		    			for (int ind : beadm.get("bg")) if (ind != -1) sizes[0]++;
		    			for (int ind : beadm.get("en")) if (ind != -1) sizes[1]++;
		    			model = sizes[0]+"-"+sizes[1]+"-man";
		    			increaseCtr(model);
		    			
//		    			System.err.print("bg ");
//			    		for (int s : beadm.get("bg")) System.err.print(s + "\t");
//			    		System.err.println();
//			    		System.err.print("en ");
//			    		for (int s : beadm.get("en")) System.err.print(s + "\t");
//			    		System.err.println("\n");

		    			mbeads.add(beadm);
		    		}
		    	}
		    		
		    	for(int j = 0; j<alignment.size(); j++) {
		    		int bgcl_index = alignment.get(j).get(0);
		    		int bglen = 0;
		    		int encl_index = alignment.get(j).get(1);
		    		int enlen = 0;
		    		String model;
		    		


		    		if (!coveredClauses.contains(bgcl_index)) {
			    		HashMap<String, ArrayList<Integer>> beada = new HashMap<String, ArrayList<Integer>>();
			    		beada.put("bg", new ArrayList<Integer>());
			    		beada.put("en", new ArrayList<Integer>());

			    		beada.get("bg").add(bgcl_index);
		    			beada.get("en").add(encl_index);

			    		for(int k = j+1; k<alignment.size(); k++) {
		    				if (bgcl_index!=-1 && alignment.get(k).get(0)==bgcl_index) {
		    					beada.get("en").add(alignment.get(k).get(1));
		    					System.out.println(alignment.get(k).get(1));

		    				}
		    				if (encl_index!=-1 && alignment.get(k).get(1)==encl_index) {
		    					beada.get("bg").add(alignment.get(k).get(0));
		    					coveredClauses.add(alignment.get(k).get(0));
		    				}
		    			}
		    			coveredClauses.add(bgcl_index);
		    			
		    			int[] sizes = {0,0};
		    			for (int ind : beada.get("bg")) if (ind != -1) sizes[0]++;
		    			for (int ind : beada.get("en")) if (ind != -1) sizes[1]++;
		    			model = sizes[0]+"-"+sizes[1]+"-auto";
		    			increaseCtr(model);
		    			
		    			String bs = NL+"bg ";
			    		for (int s : beada.get("bg")) bs += s + "\t";
			    		bs += NL+"en ";
			    		for (int s : beada.get("en")) bs += s + "\t";
			    		bs += NL;
//			    		outdist.write(bs);
			    		
			    		for (int index : beada.get("bg")) {
			    			if (index == -1) continue;
				    		Clause clbga = bga.get(bga.clauseOrder.get(index));
	
			    			if (clbga != null) bglen += clbga.lenInChars;

			    		}
	
			    		for (int index : beada.get("en")) {
			    			if (index == -1) continue;
				    		Clause clena = ena.get(ena.clauseOrder.get(index));
	
			    			if (clena != null) enlen += clena.lenInChars;

			    		}

			    		if (mbeads.contains(beada)) {
			    			increaseCtr(model.replace("auto", "cor"));
			    			increaseCtr("beads-cor-");
			    			outdist.write(model+"\tcorrect\t"+findDistMeasure(bglen,enlen,sizes[0]+","+sizes[1])+"\t"+bga.size()+"\t"+ena.size()+NL);
			    			outdist.flush();
			    		} else {
			    			outdist.write(model+"\terror\t"+findDistMeasure(bglen,enlen,sizes[0]+","+sizes[1])+"\t"+bga.size()+"\t"+ena.size()+NL);
			    			outdist.flush();
			    			
			    			if (notoutputcrdist) {
		    				boolean inv = false;
		    				boolean distant = false;
		    						    					
inv:	    				for (ArrayList<Integer> rel1 : malignment){
								if (rel1.get(0)==-1 || rel1.get(1)==-1) continue;
		    					for (ArrayList<Integer> rel2 : malignment){
		    						if (rel2.get(0)==-1 || rel2.get(1)==-1) continue;
			    					if ((rel2.get(0) > rel1.get(0) && rel2.get(1) < rel1.get(1)) 
			    						|| (rel2.get(0) < rel1.get(0) && rel2.get(1) > rel1.get(1))) {
			    						inv=true;
			    						break inv;
			    					}
			    					
		    					}
		    				}
		    				
distant:    				for (HashMap<String, ArrayList<Integer>> bead : mbeads) {
		    					
		    					for (ArrayList<Integer> l : bead.values()) {
		    						for (int ind=0; ind< l.size()-1; ind++) {
		    							if (Math.abs(l.get(ind)-l.get(ind+1))>1) {
		    								distant = true;
		    								break distant;
		    							}
		    						}
		    					}
		    					
		    				}
		    				
		    				if(inv){
		    					increaseCtr("sent-err-crossed");
				    			outcrossed.write("<word w=\""+file.getName()+"\"/>");
				    			outcrossed.write(bga.XMLsentence+NL);
				    			outcrosseden.write("<word w=\""+file.getName()+"\"/>");
				    			outcrosseden.write(ena.XMLsentence+NL);

				    			outcrossed.flush();
				    			outcrosseden.flush();
		    				}

		    				if(distant){
		    					increaseCtr("sent-err-distant");
				    			outdistant.write("<word w=\""+file.getName()+"\"/>");
				    			outdistant.write(bga.XMLsentence+NL);

				    			outdistanten.write("<word w=\""+file.getName()+"\"/>");
				    			outdistanten.write(ena.XMLsentence+NL);

				    			outdistant.flush();
				    			outdistanten.flush();
		    				}
		    				notoutputcrdist = false;
			    			}
			    		}
			    		increaseCtr("beads--");
		    		}
		    		
		    		
		    		
		    		if (malignment.contains(alignment.get(j))) {
		    			if (alignment.get(j).get(0) != -1) 
		    				increaseCtr("rel-cor-");
		    		} else {
		    			if (notoutputaserror) {
		    				
		    				
			    			increaseCtr("sent-err-bg");
			    			increaseCtr("sent-err-en");
			    			for (Clause cl : bga.values()) increaseCtrBy("words-err-bg",cl.lenInWords);
			    			for (Clause cl : ena.values()) increaseCtrBy("words-err-en",cl.lenInWords);
			    			
			    			increaseCtr(bga.size()+"_"+ena.size()+"_cl_sent-err-");

			    			if (fc > 245*c) {
			    				out.write("</text>");
			    				out.flush();
			    				out.close();
			    				out = new OutputStreamWriter(new FileOutputStream("/home/ivelina/phd/clause_alignment/results/error_sents" +c+ ".txt"),"UTF-8");
			    				out.write("<?xml version=\"1.0\" ?>\n<text current=\"0\">\n");
			    				
			    				outen.write("</text>");
			    				outen.flush();
			    				outen.close();
			    				outen = new OutputStreamWriter(new FileOutputStream("/home/ivelina/phd/clause_alignment/results/error_sents" +c+ ".al"),"UTF-8");
			    				outen.write("<?xml version=\"1.0\" ?>\n<text current=\"0\">\n");

			    				outcor.write("</text>");
			    				outcor.flush();
			    				outcor.close();
			    				outcor = new OutputStreamWriter(new FileOutputStream("/home/ivelina/phd/clause_alignment/results/correct_sents" +c+ ".txt"),"UTF-8");
			    				outcor.write("<?xml version=\"1.0\" ?>\n<text current=\"0\">\n");
			    				
			    				outcoren.write("</text>");
			    				outcoren.flush();
			    				outcoren.close();
			    				outcoren = new OutputStreamWriter(new FileOutputStream("/home/ivelina/phd/clause_alignment/results/correct_sents" +c+ ".al"),"UTF-8");
			    				outcoren.write("<?xml version=\"1.0\" ?>\n<text current=\"0\"\n>");


			    				c++;
			    			}
			    			out.write("<word w=\""+file.getName()+"\"/>");
			    			out.write(bga.XMLsentence+NL);
			    			fc++;
			    			
			    			outen.write("<word w=\""+file.getName()+"\"/>");
			    			outen.write(ena.XMLsentence+NL);
			    
			    			
			    			outcor.write("<word w=\""+file.getName()+"\"/>");
			    			outcor.write(bgm.XMLsentence+NL);
			    			

			    			outcoren.write("<word w=\""+file.getName()+"\"/>");
			    			outcoren.write(enm.XMLsentence+NL);
		    				
		    				notoutputaserror = false;
		    			}
		    			
		    			
		    		}
	/**	    		
	    			String model = beada.get("bg").size() + "-"+ beada.get("en").size() + "-";

	    			increaseCtr(model);
	    			
		    		if (m_al.containsValue(beada)) {
		    			increaseCtr(model+"c");
		    		} else {
		    			increaseCtr("sent-err-bg");
		    			increaseCtr("sent-err-en");

		    			if (fc > 245*c) {
		    				out.write("</text>");
		    				out.flush();
		    				out.close();
		    				out = new OutputStreamWriter(new FileOutputStream("/home/ivelina/phd/clause_alignment/results/error_sents" +c+ ".txt"),"UTF-8");
		    				out.write("<?xml version=\"1.0\" ?>\n<text current=\"0\">\n");
		    				
		    				outen.write("</text>");
		    				outen.flush();
		    				outen.close();
		    				outen = new OutputStreamWriter(new FileOutputStream("/home/ivelina/phd/clause_alignment/results/error_sents" +c+ ".al"),"UTF-8");
		    				outen.write("<?xml version=\"1.0\" ?>\n<text current=\"0\">\n");

		    				outcor.write("</text>");
		    				outcor.flush();
		    				outcor.close();
		    				outcor = new OutputStreamWriter(new FileOutputStream("/home/ivelina/phd/clause_alignment/results/correct_sents" +c+ ".txt"),"UTF-8");
		    				outcor.write("<?xml version=\"1.0\" ?>\n<text current=\"0\">\n");
		    				
		    				outcoren.write("</text>");
		    				outcoren.flush();
		    				outcoren.close();
		    				outcoren = new OutputStreamWriter(new FileOutputStream("/home/ivelina/phd/clause_alignment/results/correct_sents" +c+ ".al"),"UTF-8");
		    				outcoren.write("<?xml version=\"1.0\" ?>\n<text current=\"0\"\n>");


		    				c++;
		    			}
		    			out.write("<word w=\""+file.getName()+"\"/>");
		    			out.write(bga.XMLsentence+NL);
		    			fc++;
		    			
		    			outen.write("<word w=\""+file.getName()+"\"/>");
		    			outen.write(ena.XMLsentence+NL);
		    
		    			
		    			outcor.write("<word w=\""+file.getName()+"\"/>");
		    			outcor.write(bgm.XMLsentence+NL);
		    			

		    			outcoren.write("<word w=\""+file.getName()+"\"/>");
		    			outcoren.write(enm.XMLsentence+NL);
		    			
//		    			continue sentloop;
		    		}
//		    		System.out.println("*** ");

 */
		    	}
		    	
/**		    	
		    	for(String key : m_al.keySet()) {
		    		HashMap<String,ArrayList<String>> beadm = m_al.get(key);
//		    		System.out.println(key);
//		    		for (String s : beadm.get("bg")) System.out.print("mbg "+s + "\t");
//		    		System.out.println();
//		    		for (String s : beadm.get("en")) System.out.print("men "+s + "\t");
//		    		System.out.println("\n\n");
		    		
		    			String model = beadm.get("bg").size() + "-"+ beadm.get("en").size() + "-";

		    			increaseCtr(model+"e");
//		    			System.out.println("*** ");

		    	}
	*/	    	
		    	
		    	
		    	for (int j = 0; j < alignment.size(); j++) {
		    		
		    		System.out.println("("+ alignment.get(j).get(0) + "\t" + alignment.get(j).get(1) +")");
		    		 if (alignment.get(j).get(0)!=-1)  //if (alignment.get(j).get(1)!=-1) 
		    			increaseCtr("rel--");
		    	}
		    	System.out.println("***");
//		    	System.out.println("*** " + ctrs.get("1-1-c") + " " + ctrs.get("1-1-e"));

		    	for (int j = 0; j < malignment.size(); j++) {
		    		if (malignment.get(j).get(0)!=-1) //if (malignment.get(j).get(1)!=-1)
		    			increaseCtr("relm--");
		    	}
		    	
		    	int lenbg = 0;
		    	int lenen = 0;
		    	for (Clause cl : bgm.values()) {
		    		lenbg += cl.lenInChars;
		    	}
		    	for (Clause cl : enm.values()) {
		    		lenen += cl.lenInChars;
		    	}

		    	lenout.write(lenbg+"\t"+lenen+NL);
		    	System.err.println("***");
		    	
	    	}
	    	
//	    	if(ctrs.get("1-1-c")>ctrs.get("1-1-e")) System.exit(0);
	    	
	    	
	    	}
	    	  	


	    
	    
	    }
    	
 //   	System.out.println("Counters " + ctrs.get("1-0") + "\t" +ctrs.get("1-0c"));
 //      	System.out.println("Counters " + ctrs.get("all") + "\t" +ctrs.get("allc") + "\t" + ctrs.get("allc")*100.0/ctrs.get("all"));

    	for (String s : ctrs.keySet()) {
    		System.out.println(s + "\t" + ctrs.get(s));
    	}
		System.out.println("Precision: " + 1.0*ctrs.get("rel-cor-")/ctrs.get("rel--") +"\t" + "Recall: " + 1.0*ctrs.get("rel-cor-")/ctrs.get("relm--"));
    	

    	lenout.flush();
		out.write("</text>");
		outen.write("</text>");
		outcor.write("</text>");
		outcoren.write("</text>");

		outcrossed.write("</text>");
		outcrosseden.write("</text>");
		outdistant.write("</text>");
		outdistanten.write("</text>");

	    	lenout.close();
		out.flush();
		out.close();
		outen.flush();
		outen.close();
		outcor.flush();
		outcor.close();
		outcoren.flush();
		outcoren.close();
		
		outdist.flush();
		outdist.close();

		outcrossed.flush();
		outcrossed.close();

		outdistant.flush();
		outdistant.close();

		outcrosseden.flush();
		outcrosseden.close();

		outdistanten.flush();
		outdistanten.close();

		} catch (ParserConfigurationException e) {
		    e.printStackTrace();  
		} catch (SAXException e) {
		    e.printStackTrace();
		} catch (IOException e) {
		    e.printStackTrace();
		} catch(Exception e){
			e.printStackTrace();  
		} 

	}
	
/**
	public static void evaluateAlignment() throws IOException{
		
		Writer out = new OutputStreamWriter(new FileOutputStream("/home/ivelina/check.txt"),"UTF-8");
		
		for (int i = 1; i<sent_ordermbg.size(); i++) {
			out.write(i + "\t" + sent_ordermbg.get(i) + "\t" + sent_man_bg.get(sent_ordermbg.get(i)).XMLsentence + "\n");
			out.flush();
		}
		
		out.write("\n");

		for (int i = 1; i<sent_orderabg.size(); i++) {
			out.write(i + "\t" + sent_orderabg.get(i) + "\t" + sent_auto_bg.get(sent_orderabg.get(i)).XMLsentence + "\n");
			out.flush();
		}

		out.write("\n");

		for (int i = 1; i<sent_ordermen.size(); i++) {
			out.write(i + "\t" + sent_ordermen.get(i) + "\t" + sent_man_en.get(sent_ordermen.get(i)).XMLsentence + "\n");
			out.flush();
		}

		
		out.write("\n");

		for (int i = 1; i<sent_orderaen.size(); i++) {
			out.write(i + "\t" + sent_orderaen.get(i) + "\t" + sent_auto_en.get(sent_orderaen.get(i)).XMLsentence + "\n");
			out.flush();
		}

		out.flush();
		out.close();
		if(true) return;
		
		for (int i=0; i<sent_auto_bg.size(); i++) {
			
			Sentence s_bg = sent_auto_bg.get(sent_orderabg.get(i));
			Sentence s_en = new Sentence();
			if (sent_auto_en.containsKey(s_bg.id)) s_en = sent_auto_en.get(s_bg.id);
			else System.err.println("a ERROR " + i);
			
//			System.out.println(s_bg.XMLsentence);
//			System.out.println(s_en.XMLsentence);
			
		}
		for (int i=0; i<sent_man_bg.size(); i++) {
			
			Sentence s_bg = sent_man_bg.get(sent_ordermbg.get(i));
			Sentence s_en = new Sentence();
			if (sent_man_en.containsKey(s_bg.id)) s_en = sent_man_en.get(s_bg.id);
			else System.err.println("m ERROR " + i);
			
//			System.out.println(s_bg.XMLsentence);
//			System.out.println(s_en.XMLsentence);
			
		}
	
		for (int i=0; i<sent_man_en.size()-1; i++) {
			
			Sentence s_en = sent_man_en.get(sent_ordermen.get(i));
			Sentence s_en1 = sent_auto_en.get(sent_orderaen.get(i));
			System.out.println(s_en.XMLsentence);
			System.out.println(s_en1.XMLsentence);
			
		}
		
		System.out.println(sent_man_en.get(sent_ordermen.get(sent_man_en.size()-1)));
		out.close();
	}

	public static ArrayList<Double> findMinAndMax(ArrayList<Double> list){
		double min = list.get(0);
		double max = list.get(0);
		ArrayList<Double> result = new ArrayList<Double>();

		for(int index=1;index<list.size();index++) {
			if (list.get(index) < min) min = list.get(index);
			if (list.get(index) > max) max = list.get(index);
		}
			
		result.add(min);
		result.add(max);
		return result;
	}

	public static double findMean(ArrayList<Double> list){
		double mean = 0.0;
		double sum = 0.0;
		for(int index=0;index<list.size();index++)
			sum = sum + list.get(index);

		mean = sum/list.size();
		System.out.println(sum + "\t"+list.size());
		return mean;
	}

*/
	  /**
	   * Recursively walk a directory tree and return a List of all
	   * Files found; the List is sorted using File.compareTo().
	   *
	   * @param aStartingDir is a valid directory, which can be read.
	   */
	   static public List<File> getFileListing(
	     File aStartingDir
	   ) throws FileNotFoundException {
	     validateDirectory(aStartingDir);
	     List<File> result = getFileListingNoSort(aStartingDir);
	     Collections.sort(result);
	     return result;
	   }

	   // PRIVATE //
	   static private List<File> getFileListingNoSort(
	     File aStartingDir
	   ) throws FileNotFoundException {
	     List<File> result = new ArrayList<File>();
	     File[] filesAndDirs = aStartingDir.listFiles();
	     List<File> filesDirs = Arrays.asList(filesAndDirs);
	     for(File file : filesDirs) {
	       result.add(file); //always add, even if directory
	       if ( ! file.isFile() ) {
	         //must be a directory
	         //recursive call!
	         List<File> deeperList = getFileListingNoSort(file);
	         result.addAll(deeperList);
	       }
	     }
	     return result;
	   }

	   /**
	   * Directory is valid if it exists, does not represent a file, and can be read.
	   */
	   static private void validateDirectory (
	     File aDirectory
	   ) throws FileNotFoundException {
	     if (aDirectory == null) {
	       throw new IllegalArgumentException("Directory should not be null.");
	     }
	     if (!aDirectory.exists()) {
	       throw new FileNotFoundException("Directory does not exist: " + aDirectory);
	     }
	     if (!aDirectory.isDirectory()) {
	       throw new IllegalArgumentException("Is not a directory: " + aDirectory);
	     }
	     if (!aDirectory.canRead()) {
	       throw new IllegalArgumentException("Directory cannot be read: " + aDirectory);
	     }
	   }

}
