package bg.bas.dcl.CorpusTools;

import java.io.File;
import java.io.FileInputStream;
import java.io.FileNotFoundException;
import java.io.FileOutputStream;
import java.io.IOException;
import java.io.OutputStreamWriter;
import java.io.UnsupportedEncodingException;
import java.io.Writer;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.Collections;
import java.util.HashMap;
import java.util.List;
import java.util.Scanner;
import java.util.Set;

import javax.xml.parsers.DocumentBuilder;
import javax.xml.parsers.DocumentBuilderFactory;
import javax.xml.parsers.ParserConfigurationException;

import org.w3c.dom.Document;
import org.w3c.dom.Element;
import org.w3c.dom.Node;
import org.w3c.dom.NodeList;
import org.w3c.dom.bootstrap.DOMImplementationRegistry;
import org.w3c.dom.ls.DOMImplementationLS;
import org.w3c.dom.ls.LSSerializer;
import org.xml.sax.SAXException;

import bg.bas.dcl.mwe.entities.*;

public class ProcessLemmas {

    static String NL = System.getProperty("line.separator");
	final static HashMap<String,Double> priors = new HashMap<String,Double>();

    
    static HashMap<String,Integer> ctrs = new HashMap<String, Integer>();
	static int fc = 0;
	static int c = 1;
	
    public static void increaseCtr (String ctrname) {
    	int c;
    	
    	if (ctrs.containsKey(ctrname)) c = ctrs.get(ctrname) + 1;
    	else c = 1;
    	ctrs.put(ctrname, c);
    }
    public static void increaseCtrBy (String ctrname, int q) {
    	int c;
    	
    	if (ctrs.containsKey(ctrname)) c = ctrs.get(ctrname) + q;
    	else c = 1;
    	ctrs.put(ctrname, c);
    }
    
   

          
	/**
	 * 
	 * @param args
	 */
	public static void main(String[] args) {
		// TODO Auto-generated method stub
		


		String infolder = args[0];
		String outfolder = args[1];
		String punct = ".,;'#!\"?<|\\&^()+_*~$£>";
	    

		try{
			

		      
		List<File> files = getFileListing(new File(infolder));
		
	
		boolean auto = false;
		
	    for(File file : files){
	    	
	    	if (file.isFile()){
	    		
		    	if (!file.getAbsolutePath().endsWith(".al")) continue;
	    		
		    	String outtext = "";
	    		
	    		String fname = file.getAbsolutePath().substring(infolder.length());
	    		System.out.println(outfolder+fname);

		    	Writer out = new OutputStreamWriter(new FileOutputStream(outfolder+fname),"UTF-8");
				out.write("<?xml version=\"1.0\" ?><text current=\"0\">");

	    		DocumentBuilderFactory builderFactory = DocumentBuilderFactory.newInstance();
	    		DocumentBuilder builder = builderFactory.newDocumentBuilder();
	    		Document document = builder.parse(new FileInputStream(file.getAbsolutePath()));
	    		
	    		Element rootElement = document.getDocumentElement();
	    		
		    	DOMImplementationRegistry registry = DOMImplementationRegistry.newInstance();
		    	DOMImplementationLS lsImpl = 
		    	   (DOMImplementationLS)registry.getDOMImplementation("LS");
		    	LSSerializer serializer = lsImpl.createLSSerializer();

		    	NodeList nodes = rootElement.getChildNodes();
		    	
		    	boolean errorstarted = false;

		    	for(int i=0; i<nodes.getLength(); i++){
			    	  Node node = nodes.item(i);
			    	  if(node instanceof Element){
			    		  Element child = (Element) node;

				    	  String word = child.getAttribute("w").trim();
				    	  String lemma = child.getAttribute("l").trim();
			    		  String XML = serializer.writeToString(node);
						  XML = XML.replace("<?xml version=\"1.0\" encoding=\"UTF-16\"?>", "");
						  XML = XML.replace(NL, "");
				    	  
				    	  if (!errorstarted) {
							  out.write(XML);
							  out.flush();
							  
					    	  if (word.equals("--")) {
					    		  errorstarted = true;
					    	  }

							  continue;
				    	  } else {
				    		  Node node1 = nodes.item(i+1);
				    		  Element child1 = (Element) node1;
				    		  				    		  
				    		  if (punct.contains(lemma) || (!word.contains(lemma) && word.charAt(0)!=lemma.charAt(0))) {
				    			  lemma = child1.getAttribute("l").trim();
				    			  
				    			  if (!punct.contains(lemma) && (word.contains(lemma) || word.charAt(0)==lemma.charAt(0))) {
				    				  child.setAttribute("l", lemma);
				    			  } else {
				    				  lemma = word;
				    				  lemma=lemma.replaceAll("["+punct+"]+", ""); 
				    				  if (word.endsWith("s")) lemma = word.substring(0,word.length()-1);
				    				  child.setAttribute("l", lemma);
				    			  }
				    			  
				    			  XML = serializer.writeToString(child);
								  XML = XML.replace("<?xml version=\"1.0\" encoding=\"UTF-16\"?>", "");
								  XML = XML.replace(NL, "");
								  
								  if (child.getAttribute("e").equalsIgnoreCase("true")) errorstarted = false; 
				    		  } 

				    		  out.write(XML);
							  out.flush();

				    	  }
				    	  

			    	  }
		    	}
		    	
		    	
		    	out.write("</text>");
		    	out.flush();
		    	out.close();
		    	
	    	}
	    }

		} catch (ParserConfigurationException e) {
		    e.printStackTrace();  
		} catch (SAXException e) {
		    e.printStackTrace();
		} catch (IOException e) {
		    e.printStackTrace();
		} catch(Exception e){
			e.printStackTrace();  
		} 

	}
	

	  /**
	   * Recursively walk a directory tree and return a List of all
	   * Files found; the List is sorted using File.compareTo().
	   *
	   * @param aStartingDir is a valid directory, which can be read.
	   */
	   static public List<File> getFileListing(
	     File aStartingDir
	   ) throws FileNotFoundException {
	     validateDirectory(aStartingDir);
	     List<File> result = getFileListingNoSort(aStartingDir);
	     Collections.sort(result);
	     return result;
	   }

	   // PRIVATE //
	   static private List<File> getFileListingNoSort(
	     File aStartingDir
	   ) throws FileNotFoundException {
	     List<File> result = new ArrayList<File>();
	     File[] filesAndDirs = aStartingDir.listFiles();
	     List<File> filesDirs = Arrays.asList(filesAndDirs);
	     for(File file : filesDirs) {
	       result.add(file); //always add, even if directory
	       if ( ! file.isFile() ) {
	         //must be a directory
	         //recursive call!
	         List<File> deeperList = getFileListingNoSort(file);
	         result.addAll(deeperList);
	       }
	     }
	     return result;
	   }

	   /**
	   * Directory is valid if it exists, does not represent a file, and can be read.
	   */
	   static private void validateDirectory (
	     File aDirectory
	   ) throws FileNotFoundException {
	     if (aDirectory == null) {
	       throw new IllegalArgumentException("Directory should not be null.");
	     }
	     if (!aDirectory.exists()) {
	       throw new FileNotFoundException("Directory does not exist: " + aDirectory);
	     }
	     if (!aDirectory.isDirectory()) {
	       throw new IllegalArgumentException("Is not a directory: " + aDirectory);
	     }
	     if (!aDirectory.canRead()) {
	       throw new IllegalArgumentException("Directory cannot be read: " + aDirectory);
	     }
	   }

}
