package bg.bas.dcl.mwe.entities;

import java.util.ArrayList;

import bg.bas.dcl.mwe.lists.IndexLexicon;
import bg.bas.dcl.mwe.lists.IndexLexiconAlphabetical;

public class WordAlphabetic {
	
	public int[] word = new int[]{-1,-1};
	public int[] lemma = new int[]{-1,-1};
	public String pos;
	public IndexLexiconAlphabetical tokenLexicon = new IndexLexiconAlphabetical();
	public IndexLexiconAlphabetical lemmaLexicon = new IndexLexiconAlphabetical();
	
	public String wordStrForm;
	public String lemmaStrForm;
	public String cl;
	public String sen;
	public String end;
	public String p;

	public String mwe = "";
	public String mwe_type = "";

	public WordAlphabetic(){
		
	}

	public WordAlphabetic(IndexLexiconAlphabetical tokenLexicon, IndexLexiconAlphabetical lemmaLexicon){
		this.tokenLexicon = tokenLexicon;
		this.lemmaLexicon = lemmaLexicon;

	}

	public WordAlphabetic readWordFromXML(String xml) {
		
		return this;
	}
	
	public String toString(){
		return tokenLexicon.get(word[0]).get(word[1]) + "\t" + lemmaLexicon.get(lemma[0]).get(lemma[1]);
	}

	public String toXML(){
		String XML="<word ";
		String w = tokenLexicon.get(word[0]).get(word[1]);
		String l = lemmaLexicon.get(lemma[0]).get(lemma[1]);
		if (w.equals("\"")) w = "&quot;";
		if (l.equals("\"")) l = "&quot;";

		if (w.equals("&")) w = "&amp;";
		if (l.equals("&")) l = "&amp;";
		
		if (w.equals("'")) w = "&apos;";
		if (l.equals("'")) l = "&apos;";

		if (w.equals("<")) w = "&lt;";
		if (l.equals("<")) l = "&lt;";

		if (w.equals(">")) w = "&gt;";
		if (l.equals(">")) l = "&gt;";

		XML += "w=\"" + w + "\" ";
		XML += "l=\"" + l + "\" ";
		
		if (cl != null) XML += "cl=\"" + cl + "\" ";
		if (end != null) XML += "e=\"" + end + "\" ";
		if (sen != null) XML += "sen=\"" + sen + "\" ";
		if (p != null) XML += "p=\"" + p + "\" ";
		if (pos != null) XML += "pos=\"" + pos + "\" ";
		if (mwe != null && !mwe.equals("")) XML += "mwe=\"" + mwe + "\" ";
		if (mwe_type != null && !mwe_type.equals("")) XML += "mwe_type=\"" + mwe_type + "\" ";

		XML += "/>\n";
		return XML;
	}

	public String getWord(){
		return tokenLexicon.get(word[0]).get(word[1]);
	}
	
	public String getLemma(){
		return lemmaLexicon.get(lemma[0]).get(lemma[1]);
	}

	public boolean isMWE(){
		return (mwe != null) ? true : false;
	}

	public boolean isEmpty(){
		return tokenLexicon.get(word[0]).get(word[1]).equals("====") ? true : false;
	}

}
