package bg.bas.dcl.mwe.lists;

import java.io.FileNotFoundException;
import java.io.FileOutputStream;
import java.io.IOException;
import java.io.OutputStreamWriter;
import java.io.UnsupportedEncodingException;
import java.io.Writer;
import java.util.ArrayList;


public class Index {
	
	public 	static ArrayList<Integer> tokenFreqCtr = new ArrayList<Integer>();
	public 	static ArrayList<Integer> lemmaFreqCtr = new ArrayList<Integer>();

	public IndexLexicon tokenIndex = new IndexLexicon(tokenFreqCtr);
	public IndexLexicon lemmaIndex = new IndexLexicon(lemmaFreqCtr);

	static WordIndex wordIndex = new WordIndex();
	public 	static ArrayList<Integer> wordFreqCtr = new ArrayList<Integer>();

	
	public Index(){
		
	}
	
	
	public int[] addWord(String token, String lemma) {

		int i1 = tokenIndex.addEntry(token);
		int i2 = lemmaIndex.addEntry(lemma);
		
		wordIndex.addTokenLemmaPair(i1, i2);
		
		return new int[]{i1,i2};
	}

	public void printTokenFreq(String file) {
		
		Writer wr;
		try {
			wr = new OutputStreamWriter(new FileOutputStream(file), "UTF-8");
		
			for (int i =0; i < tokenFreqCtr.size(); i++) {
	
				wr.write(tokenIndex.get(i) + "\t" + tokenFreqCtr.get(i));
			}
			
			
			wr.flush();
			wr.close();
		} catch (UnsupportedEncodingException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		} catch (FileNotFoundException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		} catch (IOException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}

	}
	
	public void printLemmaFreq(String file) {

		Writer wr;
		try {
			wr = new OutputStreamWriter(new FileOutputStream(file), "UTF-8");
		
			for (int i =0; i < lemmaFreqCtr.size(); i++) {
	
				wr.write(lemmaIndex.get(i) + "\t" + lemmaFreqCtr.get(i));
			}
			
			
			wr.flush();
			wr.close();
		} catch (UnsupportedEncodingException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		} catch (FileNotFoundException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		} catch (IOException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}

	}
	
	public void printWordFreq(String file) {

		Writer wr;
		try {
			wr = new OutputStreamWriter(new FileOutputStream(file), "UTF-8");
		
			for (int i =0; i < wordFreqCtr.size(); i++) {
	
				ArrayList<Integer> word = wordIndex.get(i);
				wr.write(word.get(0) + "\t" + word.get(1) + "\t" +wordFreqCtr.get(i));
			}
			
			
			wr.flush();
			wr.close();
		} catch (UnsupportedEncodingException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		} catch (FileNotFoundException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		} catch (IOException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}

	}

}
