package bg.bas.dcl.mwe.lists;

import java.io.FileNotFoundException;
import java.io.FileOutputStream;
import java.io.IOException;
import java.io.OutputStreamWriter;
import java.io.UnsupportedEncodingException;
import java.io.Writer;
import java.util.ArrayList;


public class IndexAlphabetical {
	
	public ArrayList<ArrayList<Integer>> tokenFreqCtr = new ArrayList<ArrayList<Integer>>();
	public ArrayList<ArrayList<Integer>> lemmaFreqCtr = new ArrayList<ArrayList<Integer>>();

	public IndexLexiconAlphabetical tokenIndex = new IndexLexiconAlphabetical(tokenFreqCtr);
	public IndexLexiconAlphabetical lemmaIndex = new IndexLexiconAlphabetical(lemmaFreqCtr);

//	static WordIndex wordIndex = new WordIndex();
//	public 	static ArrayList<Integer> wordFreqCtr = new ArrayList<Integer>();

	
	public IndexAlphabetical(){
		
		for (int i=0; i < AlphabetIndex.DEFAULT+1; i++) {
			tokenFreqCtr.add(new ArrayList<Integer>());
			lemmaFreqCtr.add(new ArrayList<Integer>());
		}
		
	}
	
	
	public int[] addWord(String token, String lemma) {
		
//		token=token.toLowerCase();
		lemma=lemma.toLowerCase();

		int[] i1 = tokenIndex.addEntry(token);
		int[] i2 = lemmaIndex.addEntry(lemma);
		
		
		
		
		return new int[]{i1[0], i1[1] ,i2[0], i2[1]};
	}

	public void printTokenFreq(String file) {
		
		Writer wr;
		try {
			wr = new OutputStreamWriter(new FileOutputStream(file), "UTF-8");
		
			for (int i =0; i < tokenIndex.size(); i++) {
				for (int j =0; j < tokenIndex.get(i).size(); j++) {

					wr.write(tokenIndex.get(i).get(j) + "\t");
					wr.write(tokenFreqCtr.get(i).get(j)+"\n");
					wr.flush();
				}
			}
			
			
			wr.flush();
			wr.close();
		} catch (UnsupportedEncodingException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		} catch (FileNotFoundException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		} catch (IOException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}

	}
	
	public void printLemmaFreq(String file) {

		Writer wr;
		try {
			wr = new OutputStreamWriter(new FileOutputStream(file), "UTF-8");
		
			for (int i =0; i < lemmaIndex.size(); i++) {
				for (int j =0; j < lemmaIndex.get(i).size(); j++) {

					wr.write(lemmaIndex.get(i).get(j) + "\t");
					wr.write(lemmaFreqCtr.get(i).get(j)+"\n");
					wr.flush();
				}
			}
			
			
			wr.flush();
			wr.close();
		} catch (UnsupportedEncodingException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		} catch (FileNotFoundException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		} catch (IOException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}

	}
	
	
	public String getLemma(int[] word) {
		return lemmaIndex.get(word[0]).get(word[1]);
	}
	
	public String getToken(int[] word) {
		return tokenIndex.get(word[0]).get(word[1]);
	}
	/**
	public void printWordFreq(String file) {

		Writer wr;
		try {
			wr = new OutputStreamWriter(new FileOutputStream(file), "UTF-8");
		
			for (int i =0; i < wordFreqCtr.size(); i++) {
	
				ArrayList<Integer> word = wordIndex.get(i);
				wr.write(word.get(0) + "\t" + word.get(1) + "\t" +wordFreqCtr.get(i));
			}
			
			
			wr.flush();
			wr.close();
		} catch (UnsupportedEncodingException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		} catch (FileNotFoundException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		} catch (IOException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}

	}
*/
	
}
