package bg.bas.dcl.mwe.model;

import java.io.File;
import java.io.FileInputStream;
import java.util.Scanner;

import javax.swing.text.BadLocationException;
import javax.xml.parsers.DocumentBuilder;
import javax.xml.parsers.DocumentBuilderFactory;

import org.w3c.dom.Document;
import org.w3c.dom.Element;
import org.w3c.dom.Node;
import org.w3c.dom.NodeList;
import org.w3c.dom.bootstrap.DOMImplementationRegistry;
import org.w3c.dom.ls.DOMImplementationLS;
import org.w3c.dom.ls.LSSerializer;

import bg.bas.dcl.formats.XMLFormat;

import bg.bas.dcl.mwe.entities.*;
import bg.bas.dcl.mwe.lists.FrequencyList;
import bg.bas.dcl.mwe.lists.IndexLexicon;

public class bgMWEModel {
	
	XMLFormat format = new XMLFormat();
	
	IndexLexicon lemmaLexicon = new IndexLexicon();
	IndexLexicon tokenLexicon = new IndexLexicon();
	
	FrequencyList lemmafreq = new FrequencyList();
	FrequencyList tokenfreq = new FrequencyList();

	public bgMWEModel(){
		System.out.println("Model initialised...");
	}
	
	public Text processXML(String fname){
		Text text = new Text(fname);

		try{
/**
			Scanner s = new Scanner(new File(path), "UTF-8");
	    	
	    	while (s.hasNextLine()) {
	    		String result = model.getText(s.nextLine());
	    		doc.insertString(doc.getLength(), result+ NL,
	                     doc.getStyle("italic"));
	    	}
	*/    	
	
			DocumentBuilderFactory builderFactory = DocumentBuilderFactory.newInstance();
			DocumentBuilder builder = builderFactory.newDocumentBuilder();
			Document document = builder.parse(new FileInputStream(fname));
			
			Element rootElement = document.getDocumentElement();
			
	    	DOMImplementationRegistry registry = DOMImplementationRegistry.newInstance();
	    	DOMImplementationLS lsImpl = 
	    	   (DOMImplementationLS)registry.getDOMImplementation("LS");
	    	LSSerializer serializer = lsImpl.createLSSerializer();

	    	NodeList nodes = rootElement.getChildNodes();
	    	Sentence sen = new Sentence();
		    boolean validSent = true;

	    	for(int i=0; i<nodes.getLength(); i++){
		    	  Node node = nodes.item(i);
		    	  System.out.println(serializer.writeToString(node));
		    	  if(node instanceof Element){
		    		  Element child = (Element) node;
		    		  
					  if (!validSent) {
					  	sen = new Sentence();
					   	validSent = true;
					  }

			    	  String cl_attr = child.getAttribute("cl").trim();
			    	  String sen_attr = child.getAttribute("sen").trim();
			    	  String end_attr = child.getAttribute("e").trim();
			    	  String word = child.getAttribute("w").trim();
			    	  String lemma = child.getAttribute("l").trim();
			    	  String part = child.getAttribute("p").trim();

			    	  Word w = new Word(tokenLexicon,lemmaLexicon);
			    	//  if (w.isEmpty()) continue; 

			    	  w.lemma = lemmaLexicon.addEntry(lemma);
			    	  w.word = tokenLexicon.addEntry(word);
			    	  
			    	  sen.add(w);
			    	  
			    	  if (end_attr.equalsIgnoreCase("true")) {
			    		  text.add(sen);
			    		  validSent = false;
			    	  }
			    	  
		    	  }
	    	}

//	    	s.close();
//	    } catch (BadLocationException ble) {
//	        System.err.println("Couldn't insert initial text into text pane.");
	    } catch (Exception ex) {
	    }

		

	    		  
		
		return text;
		
	}
	
	
}
